unit hiOGLInteractive;

interface

uses kol,Share,Debug,Windows,OpenGL;

type
 THIOGLInteractive = class(TDebug)
   private
    
    procedure glDraw();
    function RetrieveObjectID(x, y: integer): integer;
   

   public
   
   _event_DrawN,_event_onSelect,_data_Width,_data_Height,_data_MouseX,_data_MouseY:THI_Event;
   IDn : integer;
   
   _prop_N:integer;
   _Data:Tdata;
   procedure _work_doDraw(var Data:Tdata; index:word);
   procedure _work_doClick(var Data:Tdata; index:word);
   procedure _work_onResize(var Data:Tdata; index:word);
   
 end;

implementation
  
 var
 
  // User variables -  
  pObj: PGLUQuadricObj;
  g_Fullscreen: boolean;
  
  //{$R *.RES}




{------------------------------------------------------------------}
{  Function to draw the actual scene                               }
{                                     }
{------------------------------------------------------------------}
procedure THIOGLInteractive.glDraw();
 

var
 i:integer;
 IDn:integer;
 NN:integer;
 
 
   
begin
  


  
  //glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
  glClearDepth(1.0);                       // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);                 // Enable Depth Buffer
  glDepthFunc(GL_LESS);		           // The Type Of Depth Test To Do

  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations

  glClear(GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer -     
  glLoadIdentity();					// Reset The matrix -  

  // We make our position a bit high and back to view the whole scene -        ,    

  // 	  Position      View	   Up Vector
  gluLookAt(0, 3, 6,     0, 0, 0,     0, 1, 0);		// This determines where the camera's position and view is -      

  glInitNames();										// This clears the name stack so we always start with 0 names. -    ,      0 

  // This next line is important.  If you don't push on at least ONE name, -   .     (push)    
  // The selection won't work.  Instead of glLoadName()/glEnd() you can use  -     .  glLoadName()/glEnd()   
  // glPushName(TheID) and glPopName();  Then you don't need to glPushName(0); -  glPushName()  glPopName();    glPushName(0);

  glPushName(0);										// This starts off the first object in the stack -   1-   

  pObj := gluNewQuadric();	// Get a new Quadric off the stack -   Quadric (?)  

  gluQuadricTexture(pObj, true); // This turns on texture coordinates for our Quadrics -        :-)

  glBegin(GL_LINES);							
  glEnd();

    NN := ReadInteger(_Data,Null,_prop_N);
    IDn := 1;
    For i := IDn to NN do
    begin
    glLoadName(IDn);
   _hi_OnEvent(_event_DrawN,IDn);
    inc (IDn);
    glEnd();
    end;
    

  gluDeleteQuadric(pObj);								// Free the Quadric

  glPopName();										// We pushed a name on the stack, we must pop it back off 

  
end;

function THIOGLInteractive.RetrieveObjectID(x, y: integer): integer;
var
   objectsFound: integer;
   viewportCoords: TGLVectori4;
   selectBuffer: array[0..31] of cardinal;
   lowestDepth: cardinal;
   selectedObject: cardinal;
   i: integer;
begin
   //objectsFound := 0;								// This will hold the amount of objects clicked
   ZeroMemory(@viewportCoords, sizeof(viewportCoords));						// We need an array to hold our view port coordinates
   ZeroMemory(@selectBuffer, sizeof(selectBuffer));
	// This will hold the ID's of the objects we click on.
	// We make it an arbitrary number of 32 because openGL also stores other information
	// that we don't care about.  There is about 4 slots of info for every object ID taken up.
														
	// glSelectBuffer is what we register our selection buffer with.  The first parameter
	// is the size of our array.  The next parameter is the buffer to store the information found.
	// More information on the information that will be stored in selectBuffer is further below.

	glSelectBuffer(32, @selectBuffer);					// Setup our selection buffer to accept object ID's

	// This function returns information about many things in OpenGL.  We pass in GL_VIEWPORT
	// to get the view port coordinates.  It saves it like a RECT with {top, left, bottom, right}

	glGetIntegerv(GL_VIEWPORT, @viewportCoords);			// Get the current view port coordinates

	// Now we want to get out of our GL_MODELVIEW matrix and start effecting our
	// GL_PROJECTION matrix.  This allows us to check our X and Y coords against 3D space.

	glMatrixMode(GL_PROJECTION);						// We want to now effect our projection matrix
	
	glPushMatrix();										// We push on a new matrix so we don't effect our 3D projection

		// This makes it so it doesn't change the frame buffer if we render into it, instead, 
		// a record of the names of primitives that would have been drawn if the render mode was
		// GL_RENDER are now stored in the selection array (selectBuffer).

		glRenderMode(GL_SELECT);						// Allows us to render the objects, but not change the frame buffer

		glLoadIdentity();								// Reset our projection matrix

		// gluPickMatrix allows us to create a projection matrix that is around our
		// cursor.  This basically only allows rendering in the region that we specify.
		// If an object is rendered into that region, then it saves that objects ID for us (The magic).
		// The first 2 parameters are the X and Y position to start from, then the next 2
		// are the width and height of the region from the starting point.  The last parameter is
		// of course our view port coordinates.  You will notice we subtract "y" from the
		// BOTTOM view port coordinate.  We do this to flip the Y coordinates around.  The 0 y
		// coordinate starts from the bottom, which is opposite to window's coordinates.
		// We also give a 2 by 2 region to look for an object in.  This can be changed to preference.

		gluPickMatrix(x, viewportCoords[3]-y-Integer(not g_Fullscreen)*(GetSystemMetrics(SM_CYCAPTION)+ GetSystemMetrics(SM_CYSIZEFRAME) shl 1), 2, 2, viewportCoords);

		// Next, we just call our normal gluPerspective() function, exactly as we did on startup.
		// This is to multiply the perspective matrix by the pick matrix we created up above. 

		gluPerspective(45.0, viewportCoords[2]/viewportCoords[3], 0.5, 150.0);
		
		glMatrixMode(GL_MODELVIEW);						// Go back into our model view matrix
	
		glDraw();									// Now we render into our selective mode to pinpoint clicked objects

		// If we return to our normal render mode from select mode, glRenderMode returns
		// the number of objects that were found in our specified region (specified in gluPickMatrix())

		objectsFound := glRenderMode(GL_RENDER);			// Return to render mode and get the number of objects found

		glMatrixMode(GL_PROJECTION);					// Put our projection matrix back to normal.
	glPopMatrix();										// Stop effecting our projection matrix

	glMatrixMode(GL_MODELVIEW);							// Go back to our normal model view matrix

	// PHEW!  That was some stuff confusing stuff.  Now we are out of the clear and should have
	// an ID of the object we clicked on.  objectsFound should be at least 1 if we found an object.

	if (objectsFound > 0) then
	begin
		// If we found more than one object, we need to check the depth values
		// of all the objects found.  The object with the LEAST depth value is
		// the closest object that we clicked on.  Depending on what you are doing,
		// you might want ALL the objects that you clicked on (if some objects were
		// behind the closest one), but for this tutorial we just care about the one
		// in front.  So, how do we get the depth value?  Well, The selectionBuffer
		// holds it.  For every object there is 4 values.  The first value is
		// "the number of names in the name stack at the time of the event, followed 
		// by the minimum and maximum depth values of all vertices that hit since the 
		// previous event, then followed by the name stack contents, bottom name first." - MSDN
		// The only ones we care about are the minimum depth value (the second value) and
		// the object ID that was passed into glLoadName() (This is the fourth value).
		// So, [0 - 3] is the first object's data, [4 - 7] is the second object's data, etc...
		// Be carefull though, because if you are displaying 2D text in front, it will
		// always find that as the lowest object.  So make sure you disable text when
		// rendering the screen for the object test.  I use a flag for RenderScene().
		// So, lets get the object with the lowest depth!		

		// Set the lowest depth to the first object to start it off.
		// 1 is the first object's minimum Z value.
		// We use an unsigned int so we don't get a warning with selectBuffer below.
		lowestDepth := selectBuffer[1];

		// Set the selected object to the first object to start it off.
		// 3 is the first object's object ID we passed into glLoadName().
		selectedObject := selectBuffer[3];

		// Go through all of the objects found, but start at the second one
		for i := 1 to objectsFound - 1 do
		begin
			// Check if the current objects depth is lower than the current lowest
			// Notice we times i by 4 (4 values for each object) and add 1 for the depth.
			if (selectBuffer[(i * 4) + 1] < lowestDepth) then
			begin
				// Set the current lowest depth
				lowestDepth := selectBuffer[(i * 4) + 1];

				// Set the current object ID
				selectedObject := selectBuffer[(i * 4) + 3];
			end
		end;
		
		// Return the selected object
		result := selectedObject;
                exit;
	end;

	// We didn't click on any objects so return 0
	result := 0;											
end;


{------------------------------------------------------------------}
{  Handle window resize                                            }
{------------------------------------------------------------------}
procedure glResizeWnd(Width, Height : Integer);
begin
  if (Height = 0) then                // prevent divide by zero exception
    Height := 1;
  glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
  glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
  glLoadIdentity();                   // Reset View
  
  gluPerspective(45.0, Width/Height, 0.5, 150.0);
  
  glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
  glLoadIdentity();                   // Reset View
end;



procedure THIOGLInteractive._work_doClick;
 var
   objectID: integer;
    x,y:integer;
  begin
 x := readinteger(_Data, _data_MouseX, 0);
 y := readinteger(_Data, _data_MouseY, 0);

objectID := RetrieveObjectID(x,y);
 if (objectID)<> 0 then
 
   begin

 _hi_onEvent(_event_onSelect,objectID); 
  
   end;  
    
end;

procedure THIOGLInteractive._work_doDraw;


begin

glDraw;

end;



procedure THIOGLInteractive._work_onResize;

var
w,h:integer;

begin
w := readinteger(_Data, _data_Width, 0);
h := readinteger(_Data, _data_Height, 0);
        glResizeWnd(w,h);
        
end;


end.                                                                                       